package ru.dbotthepony.mc.otm.menu

import net.minecraft.world.Container
import net.minecraft.world.SimpleContainer
import net.minecraft.world.entity.player.Inventory
import net.minecraft.world.entity.player.Player
import ru.dbotthepony.mc.otm.core.ImmutableList
import ru.dbotthepony.mc.otm.block.entity.CargoCrateBlockEntity
import ru.dbotthepony.mc.otm.entity.MinecartCargoCrate
import ru.dbotthepony.mc.otm.registry.MMenus

class MinecartCargoCrateMenu @JvmOverloads constructor(
	p_38852_: Int,
	inventory: Inventory,
	val cart: MinecartCargoCrate? = null
) : MatteryMenu(MMenus.CARGO_CRATE, p_38852_, inventory) {
	override val storageSlots: List<MatterySlot>

	init {
		val container = cart as Container? ?: SimpleContainer(CargoCrateBlockEntity.CAPACITY)

		storageSlots = ImmutableList(CargoCrateBlockEntity.CAPACITY) {
			val slot = MatterySlot(container, it)
			addSlot(slot)
			return@ImmutableList slot
		}

		addInventorySlots()
	}

	override fun stillValid(player: Player): Boolean {
		return cart?.stillValid(player) ?: true
	}
}
